---
layout: sec_direction
title: Product Stage Direction - Application Security Testing
description: "The Secure Section focuses on identifying security findings within applications and services prior to moving them to operations. Learn more!"
canonical_path: "/direction/application_security_testing/" 
---

## On this page
{:.no_toc}

- TOC
{:toc}

<p align="center">
    <font size="+2">
        <b>Proactively identify security vulnerabilities and weaknesses in applications and services via a suite of highly performant & accurate application security scanners</b>
    </font>
</p>

<%= partial("direction/application_security_testing/templates/overview") %>

<%= devops_diagram(["Application Security Testing"]) %>

## Stage Overview

> GitLab was named as a [Challenger in the 2022 Magic Quadrant for Application Security Testing](https://about.gitlab.com/analysts/gartner-ast22/).

The Application Security Testing Stage focuses on identifying security findings (e.g., vulnerabilities and weaknesses) within applications and services prior to moving them to operations. Furthermore, Secure can (and will) provide security visibility for applications and services already deployed to production. Secure’s goal is to proactively identify vulnerabilities and weaknesses before they are exploited.  This is done by:

* Applying a proactive approach to security with a focus on identifying security findings
* Analyzing applications and services including cloud-native infrastructure for security vulnerabilities and weaknesses
* Leveraging common methods including ethical hacking and fuzz testing as well as static and dynamic analysis

### Groups

The Application Security Testing stage is made up of 5 groups: 

* Static Analysis - Assess applications and services for vulnerabilities and weaknesses by scanning source code. 
* Secret Detection - Assess code to prevent leaked secrets, before and after commit.
* Dynamic Analysis - Assess running applications and services for vulnerabilities and weaknesses by analyzing application behavior at runtime.
* Composition Analysis - Assess applications and services by analyzing your dependencies and containers for vulnerabilities and weaknesses. Confirm that only approved licenses are in use.
* Vulnerability Research - Lead the ideation and evolution of GitLab’s security capabilities via the application of innovative security research and emerging technologies. Curate high-quality detection rules across GitLab’s suite of security analyzers. 

## 3 Year Stage Themes

<%= partial("direction/application_security_testing/templates/themes") %>

## 3 Year Strategy

In three years the Secure Stage market will:
* Have the application security testing (AST) market continue to grow, adding new techniques into its definition
    * This includes a bigger focus on API readiness with API fuzzing and security testing growing in popularity
    * See a resurgence of security testing within operations / production
* Continue the "Shift Left" trend, with Static Analysis (SAST) becoming more prominent
* Adopt machine learning techniques within the development phases of the DevOps lifecycle

As a result, in three years, Gitlab will:
* Identify insecure coding practices in real-time and provide recommendations to correct them prior to merge request
* Provide fuzz testing across the entire application technology stack (protocol, API, application), including both black-box and white-box testing techniques
* Expand Secure to support testing in development as well as in operations / production
    * Introduce categories that enable continuous verification (e.g., hourly, daily, weekly) of operations / production
* Expand focus within preexisting categories to apply knowledge / results from one scan type to optimize another scan type's configuration

## 1 Year Plan

Please explore the individual [Category](https://about.gitlab.com/direction/application_security_testing/#categories) direction pages for more information on 12 month plans. Internal GitLab team members can view the 12 month roadmap for the AST stage and all groups there in [here](https://10az.online.tableau.com/#/site/gitlab/views/SecureLighthouseMetricsWorksheets/ParentNamespaceswithResolvedVulnerabilities?:iid=1). 

## Target audience

GitLab identifies who our DevSecOps application is built for utilizing the following categorization. Definitions of our user personas can be found [here](https://handbook.gitlab.com/handbook/product/personas/#list-of-user-personas). 
* 🟩 - Targeted with strong support
* 🟨 - Targeted but incomplete support
* ⬜️ - Not targeted but might find value

### Today
To capitalize on the [opportunities](#opportunities) listed above, the Secure Stage has features that make it useful to the following personas today.
1. 🟩  Developers / Development Teams
1. 🟩  Security Teams
1. 🟨  SecOps Teams
1. 🟩  QA engineers / QA Teams
1. 🟨  Security Consultants
1. 🟨  Compliance Specialists / Manager

### Medium Term (1-2 years)
As we execute our [3 year strategy](#3-year-strategy), our medium term (1-2 year) goal is to provide a single DevSecOps application that enables collaboration between developers, security teams, SecOps teams, and QA Teams.
1. 🟩  Developers / Development Teams
1. 🟩  Security Teams
1. 🟩  SecOps Teams
1. 🟩  QA engineers / QA Teams
1. 🟨️  Security Consultants
1. 🟨️  Compliance Specialists / Manager

<%= partial("direction/categories", :locals => { :stageKey => "application_security_testing" }) %>

## Pricing
<%= partial("direction/application_security_testing/templates/pricing") %>

<p align="center">
    <i><br>
    Last Reviewed: 2021-12-13<br>
    Last Updated: 2021-12-13
    </i>
</p>
